import processing.serial.*;

import java.io.*;
import gnu.io.*;

  int X = 0;
  int Y = 1;
  int Z = 2;
  int Aaxis = 3;
  int Baxis = 4;
  int Caxis = 5;
  int AxisMax = 1 + Caxis;
  
  int MoveMode =6;
  int Distance = 7;
  int Speed = 8;
  int SpindleRev = 9;
  int StatusMax = 1 + SpindleRev;

CNCMachineControl CNC = new CNCMachineControl();
CNCControlTaskThread TaskThread = new CNCControlTaskThread();
SerialPort CNCPort;

int RateCounter  = 0;

// 複数キーイベント取得
int  [] KeyStatus = new int[256];

void setup(){
  size(600,400);
  frameRate(20);
  CNC.MachineInitialize("MDX20.ini");
  CNCPortSetup();
  CNC.OutputFile("TestRML.prn");


  TaskThread.Control = CNC;
  TaskThread.start();
  TaskThread.pause = false;
  
}

void draw(){

 float DeltaTime=((millis() - RateCounter)/1000.0);
 RateCounter=millis();

     CNC.Process(DeltaTime);

     if(KeyStatus[32] == 255){
       TaskThread.pause = true;
     }
     if(KeyStatus[10] == 255){
       TaskThread.pause = false;
     }
         
      background(0);
      int Next = CNC.GetNextOfBaseIndex();
      fill(255,255,0);
      rect(200,60,204,153);
  
      fill(0,255,0);
      ellipseMode(CENTER);
      ellipse(200+CNC.MoveData[Next][X],210-CNC.MoveData[Next][Y], 10, 10);
  
      fill(255,0,0);
      ellipseMode(CENTER);
      ellipse(200+CNC.CurrentStatus[X],210-CNC.CurrentStatus[Y], 10, 10);

      int Num = CNC.GetNumOfMoveData() ;
      for(int i = Num; i > 0; i--){
        int j = CNC.GetIndexOfBase(i);
        int k = CNC.GetIndexOfBase(i-1);
        if(CNC.MoveDataSendFlag[j] == 0){
          stroke(0,192,0);
        }else{
          stroke(192,0,0);
        }
        
        line(200+CNC.MoveData[j][X],210-CNC.MoveData[j][Y],
              200+CNC.MoveData[k][X],210-CNC.MoveData[k][Y]);
      }
      
      fill(255,255,255);
      rect(25,45,80,25);
      rect(25,75,80,25);
      rect(25,105,80,25);
      rect(25,135,80,25);
      rect(25,175,80,25);
      rect(25,205,80,25);
      rect(25,235,80,25);
      
      fill(0,0,0,255);
  //    text(FloatString(framerate2,1)+"FPS",260,30);
      text("X "+ FloatString(CNC.CurrentStatus[X],3) ,30,60);  
      text("Y "+ FloatString(CNC.CurrentStatus[Y],3) ,30,90);  
      text("Z "+ FloatString(CNC.CurrentStatus[Z],3) ,30,120);      
      text("Speed "+ FloatString(CNC.CurrentStatus[Speed],3) ,30,150);      
  
      text("Next X "+ FloatString(CNC.MoveData[Next][X],3) ,30,190);  
      text("Next Y "+ FloatString(CNC.MoveData[Next][Y],3) ,30,220);  
      text("Next Z "+ FloatString(CNC.MoveData[Next][Z],3) ,30,250);
}

void stop(){
  CNCPort.close();
}

void CNCPortSetup(){
  if(CNC.PortName != null){
    for(int i = 0;i < Serial.list().length;i++){
      if(CNC.PortName.equals(Serial.list()[i])){
        println("Port "+ CNC.PortName +" detect");
       //使用するCOMポートを取得
       CommPortIdentifier comID = null;
       try{
         comID = CommPortIdentifier.getPortIdentifier( CNC.PortName );
       } catch (NoSuchPortException ex) {
           ex.printStackTrace();
       }
       
       CommPort commPort = null;
       if(comID != null){
         //COMポートを開きます
         try{
           commPort = comID.open("CNCContronPanel",2000);
          } catch (PortInUseException ex) {
              ex.printStackTrace();
          }
              
 
          
         //シリアルポートのインスタンスを生成…
         CNCPort = (SerialPort)commPort;        
  
         //ボーレート、データビット数、ストップビット数、パリティを設定
         try{
           CNCPort.setSerialPortParams( 9600,SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE );
         } catch (UnsupportedCommOperationException ex) {
            ex.printStackTrace();
         }
         //フロー制御
         try{
           CNCPort.setFlowControlMode( SerialPort.FLOWCONTROL_RTSCTS_IN | SerialPort.FLOWCONTROL_RTSCTS_OUT );
         } catch (UnsupportedCommOperationException ex) {
            ex.printStackTrace();
         }
       }        
       println("Port "+ CNC.PortName +" open");

        CNC.PortSetup(CNCPort);

      }
    }
  }
}  

//複数キーイベント取得
public void processKeyEvent( KeyEvent e ) {
//System.out.println( e );
  int nCode = e.getKeyCode();
  if ( e.getID() == KeyEvent.KEY_PRESSED ) {
    KeyStatus[nCode] = 255;
  }
  if ( e.getID() == KeyEvent.KEY_RELEASED ) { 
    KeyStatus[nCode] = 254;
  }
}


String FloatString(Float f,int FractionDigit){
   String s = Float.toString(f);
   int end = s.indexOf('.')+FractionDigit+1;
   if (end > s.length()){
     end = s.length();
   }
   s =s.substring(0,end);
   return s;
}  

